package org.mmga.clubs.configuration;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.io.File;
import java.io.IOException;

@Configuration
public class DirConfiguration {
    private File tempDir;
    private File avatarDir;
    @Bean
    public File tempDir() throws IOException {
        if (this.tempDir != null) {
            return this.tempDir;
        }
        this.tempDir = new File("tmp");
        if (!this.tempDir.exists()) {
            if (!this.tempDir.mkdir()) {
                throw new IOException("Failed to create temp dir");
            }
        }
        return this.tempDir;
    }
    @Bean
    public File avatarDir() throws IOException {
        if (this.avatarDir != null) {
            return this.avatarDir;
        }
        this.avatarDir = new File("avatar");
        if (!this.avatarDir.exists()) {
            if (!this.avatarDir.mkdir()) {
                throw new IOException("Failed to create avatar dir");
            }
        }
        return this.avatarDir;
    }
}
