package org.mmga.clubs.service;

import org.mmga.clubs.dao.RouterDao;
import org.mmga.clubs.entities.router.Router;
import org.mmga.clubs.entities.router.RouterVo;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class RouterService {
    private final RouterDao routerDao;
    public RouterService(RouterDao routerDao) {
        this.routerDao = routerDao;
    }
    public List<Router> packageRouter(List<RouterVo> routerVos) {
        Map<Integer, Router> idRouterMap = new HashMap<>();
        List<Integer> rootId = new ArrayList<>();
        for (RouterVo routerVo : routerVos) {
            idRouterMap.put(routerVo.id(), new Router(routerVo.id(), routerVo.name(), routerVo.component(), new ArrayList<>()));
            if (routerVo.parent() == null){
                rootId.add(routerVo.id());
            }
        }
        for (RouterVo routerVo : routerVos) {
            Integer parent = routerVo.parent();
            if (parent != null) {
                idRouterMap.get(parent).getChildren().add(idRouterMap.get(routerVo.id()));
            }
        }
        return rootId.stream().map(idRouterMap::get).toList();
    }
}
